# coding: utf-8

"""
    FastAPI

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr, conlist
from multinode.api_client.models.execution_spec import ExecutionSpec
from multinode.api_client.models.execution_summary import ExecutionSummary
from multinode.api_client.models.function_status import FunctionStatus
from multinode.api_client.models.invocation_status import InvocationStatus
from multinode.api_client.models.parent_invocation_info import ParentInvocationInfo
from multinode.api_client.models.prepared_function_details import PreparedFunctionDetails
from multinode.api_client.models.resource_spec import ResourceSpec

class InvocationInfo(BaseModel):
    """
    InvocationInfo
    """
    project_name: StrictStr = Field(...)
    version_id: StrictStr = Field(...)
    function_name: StrictStr = Field(...)
    invocation_id: StrictStr = Field(...)
    parent_invocation: Optional[ParentInvocationInfo] = Field(...)
    resource_spec: ResourceSpec = Field(...)
    execution_spec: ExecutionSpec = Field(...)
    function_status: FunctionStatus = Field(...)
    prepared_function_details: Optional[PreparedFunctionDetails] = Field(...)
    input: StrictStr = Field(...)
    cancellation_request_time: Optional[StrictInt] = Field(...)
    invocation_status: InvocationStatus = Field(...)
    creation_time: StrictInt = Field(...)
    last_update_time: StrictInt = Field(...)
    executions: conlist(ExecutionSummary) = Field(...)
    __properties = ["project_name", "version_id", "function_name", "invocation_id", "parent_invocation", "resource_spec", "execution_spec", "function_status", "prepared_function_details", "input", "cancellation_request_time", "invocation_status", "creation_time", "last_update_time", "executions"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> InvocationInfo:
        """Create an instance of InvocationInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of parent_invocation
        if self.parent_invocation:
            _dict['parent_invocation'] = self.parent_invocation.to_dict()
        # override the default output from pydantic by calling `to_dict()` of resource_spec
        if self.resource_spec:
            _dict['resource_spec'] = self.resource_spec.to_dict()
        # override the default output from pydantic by calling `to_dict()` of execution_spec
        if self.execution_spec:
            _dict['execution_spec'] = self.execution_spec.to_dict()
        # override the default output from pydantic by calling `to_dict()` of prepared_function_details
        if self.prepared_function_details:
            _dict['prepared_function_details'] = self.prepared_function_details.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in executions (list)
        _items = []
        if self.executions:
            for _item in self.executions:
                if _item:
                    _items.append(_item.to_dict())
            _dict['executions'] = _items
        # set to None if parent_invocation (nullable) is None
        # and __fields_set__ contains the field
        if self.parent_invocation is None and "parent_invocation" in self.__fields_set__:
            _dict['parent_invocation'] = None

        # set to None if prepared_function_details (nullable) is None
        # and __fields_set__ contains the field
        if self.prepared_function_details is None and "prepared_function_details" in self.__fields_set__:
            _dict['prepared_function_details'] = None

        # set to None if cancellation_request_time (nullable) is None
        # and __fields_set__ contains the field
        if self.cancellation_request_time is None and "cancellation_request_time" in self.__fields_set__:
            _dict['cancellation_request_time'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> InvocationInfo:
        """Create an instance of InvocationInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return InvocationInfo.parse_obj(obj)

        _obj = InvocationInfo.parse_obj({
            "project_name": obj.get("project_name"),
            "version_id": obj.get("version_id"),
            "function_name": obj.get("function_name"),
            "invocation_id": obj.get("invocation_id"),
            "parent_invocation": ParentInvocationInfo.from_dict(obj.get("parent_invocation")) if obj.get("parent_invocation") is not None else None,
            "resource_spec": ResourceSpec.from_dict(obj.get("resource_spec")) if obj.get("resource_spec") is not None else None,
            "execution_spec": ExecutionSpec.from_dict(obj.get("execution_spec")) if obj.get("execution_spec") is not None else None,
            "function_status": obj.get("function_status"),
            "prepared_function_details": PreparedFunctionDetails.from_dict(obj.get("prepared_function_details")) if obj.get("prepared_function_details") is not None else None,
            "input": obj.get("input"),
            "cancellation_request_time": obj.get("cancellation_request_time"),
            "invocation_status": obj.get("invocation_status"),
            "creation_time": obj.get("creation_time"),
            "last_update_time": obj.get("last_update_time"),
            "executions": [ExecutionSummary.from_dict(_item) for _item in obj.get("executions")] if obj.get("executions") is not None else None
        })
        return _obj


